#include "resource.h"
#include "dbttip.h"

//---------------------------------------------------------------------------
// Create our property popup-window.  Since we want to put up a dialog, this
// window never becomes visible.  Instead, when asked to become visible, it
// will post a message to itself, remining it to put up our dialog.
//
// NOTE: May return NULL!
//---------------------------------------------------------------------------
HWND NEAR HwndInitAboutBox(VOID)
{
 return CreateWindow( CLASS_ABOUTBOX, NULL, WS_POPUP,0, 0, 0, 0, NULL, NULL, ghmodDLL, NULL );
}

//---------------------------------------------------------------------------
// We asked to show ourself, remain invisible and post a CM_OPENABOUT to
// ourself.  When we receive this message, open the dialog box.
//---------------------------------------------------------------------------
LONG _export FAR PASCAL AboutBoxProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
 switch ( msg )
  {
   case WM_SHOWWINDOW:
     if ( wParam )
	  {
	   PostMessage(hWnd, CM_OPENABOUTBOX, 0, 0L);
	   return 0L;
	  }
     break;
   case CM_OPENABOUTBOX:
     VBDialogBoxParam(ghmodDLL, "AboutBox", (FARPROC)AboutBoxDlgProc, 0L);
	 return 0L;
  }
 return DefWindowProc(hWnd, msg, wParam, lParam);
}


//---------------------------------------------------------------------------
// The Dialog Procedure for the AboutBox dialog.
//---------------------------------------------------------------------------
BOOL FAR PASCAL _export AboutBoxDlgProc(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam)
{
 switch (msg)
  {
   case WM_INITDIALOG:
    {
     RECT rect;
	 int  nx, ny;	  // New x and y
	 int  width, height;

	 // Position dialog so it looks nice:
	 GetWindowRect(hDlg, &rect);
	 width  = rect.right - rect.left;
	 height = rect.bottom - rect.top;
	 nx = (GetSystemMetrics(SM_CXSCREEN) - width)  / 2;
	 ny = (GetSystemMetrics(SM_CYSCREEN) - height) / 3;
	 MoveWindow(hDlg, nx, ny, width, height, FALSE);
	 return TRUE;
    }

   case WM_COMMAND:
     if ( wParam == IDOK )
      {
	   EndDialog( hDlg, TRUE );
       return TRUE;
      }
     break;

   case WM_ERASEBKGND: {
     RECT rect;
     char szMe[300];
     int nLen;
     GetClipBox( (HDC)wParam, &rect);
     FillRect( (HDC)wParam, &rect, GetStockObject(LTGRAY_BRUSH) );
     if ( nLen = LoadString(ghmodDLL,IDS_ABOUTTEXT,szMe,sizeof(szMe)-1) )
      {
       GetClientRect(hDlg,&rect);
       rect.left = rect.right/16;
       rect.right = (short)( ((long)rect.right*15L)/16L );
       rect.top = rect.bottom/8;
       SetBkMode( (HDC)wParam, TRANSPARENT );
       DrawText( (HDC)wParam, szMe, nLen, &rect, DT_WORDBREAK|DT_CENTER );
      }
     return TRUE; }

  }
 return FALSE;
}

