//---------------------------------------------------------------------------
// Written 1995 By Dan Bystrm
//---------------------------------------------------------------------------
// DBTTip.h
//---------------------------------------------------------------------------

#include <windows.h>
#include <vbapi.h>


//---------------------------------------------------------------------------
// Resource Information
//---------------------------------------------------------------------------
// Toolbox bitmap resource IDs.
//---------------------------------------------------------------------------
#define IDBMP_TTIP			8000
#define IDBMP_TTIPDOWN		8001
#define IDBMP_TTIPMONO		8003
#define IDBMP_TTIPEGA		8006

//---------------------------------------------------------------------------
// Change these for each new VBX file
//---------------------------------------------------------------------------
#define VBX_COMPANYNAME			"Visual Design AB\0"
#define VBX_FILEDESCRIPTION		"Tool tips for VB\0"
#define VBX_INTERNALNAME		"DBTTIP\0"
#define VBX_LEGALCOPYRIGHT		"Written 1995 by Dan Bystrm\0"
#define VBX_LEGALTRADEMARKS		"Public domain software\0"
#define VBX_ORIGINALFILENAME	"DBTTIP.VBX\0"
#define VBX_PRODUCTNAME			"DBTTIP\0"


//---------------------------------------------------------------------------
// Update these fields for each build.
//---------------------------------------------------------------------------
#define VBX_VERSION				1,32,0,00
#define VBX_VERSION_STR			"1.32.000\0"
#define VBX_VERSION_WORD		0x0132

#ifndef RC_INVOKED
//---------------------------------------------------------------------------
// Macro for referencing member of structure
//---------------------------------------------------------------------------
#define OFFSETIN(struc, field)	  ((USHORT)&(((struc *)0)->field))

#define FAST_POPUP 32767

HWND NEAR HwndInitAboutBox(VOID);
LONG _export FAR PASCAL AboutBoxProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam);
BOOL FAR PASCAL _export AboutBoxDlgProc(HWND   hDlg, UINT msg, WPARAM wParam, LPARAM lParam);
#define CM_OPENABOUTBOX     WM_USER
#define CLASS_ABOUTBOX "AboutBoxClass"

#define PMODE_AUTOMATIC	0
#define PMODE_MANUAL	1

//---------------------------------------------------------------------------
// TTIP control data and structs
//---------------------------------------------------------------------------

typedef enum tagTIPSTATUS
  { TIPPING_NONE, TIPPING_VISIBLE, TIPPING_INVISIBLE } TIPSTATUS;

typedef struct tagUNIQUE
 {
    HPIC	hPic;					// background "bubble"
    COLORREF rgbForeColor;			// text color
    HFONT	hFont;					// text font
	short	nAlignment;				// text alignment

	short	nTextLeft, nTextTop, nTextRight, nTextBottom;
	short	nHotSpotX, nHotSpotY;
	short	nMouseOffX, nMouseOffY;
	short	nAspect;

	short	nTractorBeam;
	short	nSensivity;

 } UNIQUE;

typedef struct tagTTIP
 {
    HSZ		hszAbout;

	UNIQUE	uMe;
	UNIQUE	uUse;

    short	nUseIndex;
    BOOL	bCtlEnabled;			// 950916 v1.3
	short	nExtraOffX, nExtraOffY;

    short	nDelay;					// delay before popup
    short	PopupMode;

	POINT	pMouse;
	POINT	pMouseOrgPos;
	HWND	hWndTip;

	short	nCountDown;
	RECT	rectCapture;
    HCTL	hctlTipping;
	TIPSTATUS TipStatus;
	HWND	hwndKnownContainer;

	RECT	rectText;				// set by "AdjustTipSize"
    short	nTipWidth, nTipHeight;	// set by "AdjustTipSize"
    HSZ		hszText;

 } DBTTIP;

typedef DBTTIP FAR * LPDBTTIP;

#define LPDBTTIPDEREF(hctl)     ((LPDBTTIP)VBDerefControl(hctl))


//---------------------------------------------------------------------------
// Control Procedure
//---------------------------------------------------------------------------
LONG FAR PASCAL _export TTipCtlProc(HCTL, HWND, USHORT, USHORT, LONG);


//---------------------------------------------------------------------------
// Property list
//---------------------------------------------------------------------------
// Define the consecutive indicies for the properties
//---------------------------------------------------------------------------
#define IPROP_TTIP_NAME				 0
#define IPROP_TTIP_INDEX			 1
#define IPROP_TTIP_PARENT			 2
#define IPROP_TTIP_LEFT				 3
#define IPROP_TTIP_TOP				 4
#define IPROP_TTIP_WIDTH			 5
#define IPROP_TTIP_HEIGHT			 6
#define IPROP_TTIP_FONTNAME			 7
#define IPROP_TTIP_FONTSIZE			 8
#define IPROP_TTIP_FONTBOLD			 9
#define IPROP_TTIP_FONTITALIC		10
#define IPROP_TTIP_FONTSTRIKE		11
#define IPROP_TTIP_FONTUNDER		12
#define IPROP_TTIP_TAG				13

#define IPROP_TTIP_ABOUTBOX			14
#define IPROP_TTIP_ALIGNMENT		15
#define IPROP_TTIP_ASPECT			16
#define IPROP_TTIP_DELAY			17
#define IPROP_TTIP_EXTRAOFFX		18
#define IPROP_TTIP_EXTRAOFFY		19
#define IPROP_TTIP_FORECOLOR		20
#define IPROP_TTIP_HOTSPOTX			21
#define IPROP_TTIP_HOTSPOTY			22
#define IPROP_TTIP_ISVISIBLE		23
#define IPROP_TTIP_MOUSEOFFX		24
#define IPROP_TTIP_MOUSEOFFY		25
#define IPROP_TTIP_PICTURE			26
#define IPROP_TTIP_TEXTBOTTOM		27
#define IPROP_TTIP_TEXTLEFT			28
#define IPROP_TTIP_TEXTRIGHT		29
#define IPROP_TTIP_TEXTTOP			30
#define IPROP_TTIP_TRACTORBEAM		31
#define IPROP_TTIP_POPUPMODE		32
#define IPROP_TTIP_SENSIVITY		33
#define IPROP_TTIP_USEINDEX			34
#define IPROP_TTIP_CTLENABLED		35


//---------------------------------------------------------------------------
// Event procedure parameter prototypes
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
// Event list
//---------------------------------------------------------------------------
// Define the consecutive indicies for the events
//---------------------------------------------------------------------------

typedef struct tagPARAMS {
  float	FAR *y;
  float	FAR *x;
  HLSTR		hlStr;
  HWND FAR *lphWnd;
  short FAR *lpnIndex;
  HLSTR		hlCtlName;
  LPVOID    Index;
 } PARAMS;

#define IEVENT_TTIP_POPUP			 0
#define IEVENT_TTIP_POPDOWN			 1


extern HANDLE ghmodDLL;
extern char szDBTTip[];

#endif // RC_INVOKED

//---------------------------------------------------------------------------
